import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.stream.Stream;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class xor_partition_lewin {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        XorPartition solver = new XorPartition();
        solver.solve(1, in, out);
        out.close();
    }

    static class XorPartition {
        List<Integer>[] ps;
        int mod = 1000000007;

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            int m = in.nextInt(), n = in.nextInt();
            int M = 1 << m;
            int[] p = in.readIntArrayAndDecrementOne(M);
            ps = LUtils.genArrayList(n);
            for (int i = 0; i < M; i++) ps[p[i]].add(i);
            HashSet<Integer> g = new HashSet<>();
            for (int i = 0; i < n; i++) g.add(i);
            out.println(count(m - 1, g));
        }

        public int count(int bit, HashSet<Integer> g) {
            if (g.size() == 0) return 1;
            if (g.size() == 1) return (1 << (bit + 1)) % mod;
            if (bit < 0) return 0;
            HashSet<Integer> first = new HashSet<>();
            HashSet<Integer> second = new HashSet<>();
            int count = 0;
            for (int k : g) {
                boolean hasone = false, haszero = false;
                for (int t : ps[k]) {
                    if (((t >> bit) & 1) == 1) hasone = true;
                    else haszero = true;
                }
                if (!hasone && !haszero) return 0;
                if (hasone && haszero) count++;
                if (hasone) first.add(k);
                else second.add(k);
            }
            if (count == g.size()) return 2 * count(bit - 1, g) % mod;
            else if (count == 0) return (int) (1L * count(bit - 1, first) * count(bit - 1, second) % mod);
            else return 0;
        }

    }

    static class LUtils {
        public static <E> List<E>[] genArrayList(int size) {
            return Stream.generate(ArrayList::new).limit(size).toArray(List[]::new);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int[] readIntArrayAndDecrementOne(int tokens) {
            int[] ret = new int[tokens];
            for (int i = 0; i < tokens; i++) {
                ret[i] = nextInt() - 1;
            }
            return ret;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(int i) {
            writer.println(i);
        }

    }
}

